#include <InitGuid.h>

#include "TestBed.h"
#include "DevGuid.h"

void	SprintGuid( TCHAR *szBuf, GUID *pGuid);
DWORD	GetDevices( GUID *pGuid);


int TestFunction( void)
{
TCHAR	szBuf1[50];

logln("Hello from TestFunction\n");

SprintGuid( szBuf1, (GUID*)&GUID_DEVCLASS_HIDCLASS);
logln( TEXT("\nGUID Human interface devices = %s"), szBuf1);
GetDevices( (GUID*)&GUID_DEVCLASS_HIDCLASS);

SprintGuid( szBuf1, (GUID*)&GUID_DEVCLASS_MOUSE);
logln( TEXT("\nGUID Mice = %s"), szBuf1);
GetDevices( (GUID*)&GUID_DEVCLASS_MOUSE);

return 1;
}


void	SprintGuid( TCHAR *szBuf, GUID *pGuid)
{
_stprintf( szBuf,
	TEXT("{%8.8X-%4.4X-%4.4X-%2.2X%2.2X-%2.2X%2.2X%2.2X%2.2X%2.2X%2.2X}"),
	pGuid->Data1, pGuid->Data2, pGuid->Data3,
	pGuid->Data4[0], pGuid->Data4[1],
	pGuid->Data4[2], pGuid->Data4[3],
	pGuid->Data4[4], pGuid->Data4[5],
	pGuid->Data4[6], pGuid->Data4[7]);
}



// The following was derived from code by Calvin Guan
// originally posted on microsoft.public.development.device.drivers

DWORD GetDevices( GUID *pGuid)
{
TCHAR				szBuf[50];
HDEVINFO			devInfo;
SP_DEVINFO_DATA			devInfoData;
SP_DEVICE_INTERFACE_DATA	devInterfaceData;
SP_DEVINFO_LIST_DETAIL_DATA	devInfoSetDetailData;
DWORD				cnt=0;
BOOL				retval;

devInfo = SetupDiGetClassDevsEx(
	pGuid,
	NULL,
	NULL,
	DIGCF_PRESENT,
	NULL,
	NULL,
	NULL);

if (NULL == devInfo)
	{
	logwe("SetupDiGetClassDevsEx");
	return 0;
	}

do	{
	memset(&devInfoData,0,sizeof(devInfoData));
	devInfoData.cbSize = sizeof(devInfoData);

	if ((retval=SetupDiEnumDeviceInfo(devInfo,cnt,&devInfoData))!=FALSE)
		{
		logln(TEXT("Device[%u] (DevInst: %8.8Xh)"),
			cnt, devInfoData.DevInst);

		if (SetupDiGetDeviceRegistryProperty(
				devInfo,
				&devInfoData,
				SPDRP_DEVICEDESC,
				NULL,
				(PBYTE)szBuf,
				sizeof(szBuf),
				NULL))
			log(" Desc: %s\n",szBuf);
		else	logwe(NULL);
		logln(NULL);
		cnt++;
		}
	}
while (retval != FALSE);

if ((retval == FALSE) && (GetLastError()!=ERROR_NO_MORE_ITEMS))
	{
	logwe( TEXT("Problem with 'SetupDiEnumDeviceInterfaces'"));
	return 0;
	}

log(TEXT("%u device(s) were enumerated\n\n"), cnt);

return cnt;
}

